
using System;
using System.Xml;
using System.Web;
using System.Collections;

namespace CurrencyService
{
	
	
	public class DataAccess
	{
		public struct cur{
			public string name;
			public string ratio;
		}
		private string filename;
		
		public DataAccess()
		{
			filename = HttpContext.Current.Server.MapPath("currencies.xml");
		}
		
		public DataAccess(string filename){
			this.filename = filename;	
		}
		
		public double convert(string from, string to, double amount){
			return convert(from,to)*amount;	
		}
		
		public double convert(string from, string to){
			cur[] all = readXml();
			string fromRatio="0", toRatio="0";
			foreach (cur c in all){
				if (c.name==from)
					fromRatio = c.ratio;
				if(c.name==to)
					toRatio = c.ratio;
			}
			if ((fromRatio=="0") || (toRatio=="0"))
				return -1;
			else
				return (double.Parse(fromRatio)/double.Parse(toRatio));
		}
		
		public void writeXml(string name, string ratio){
			cur c;
			c.name = name;
			c.ratio = ratio;
			writeXml(c);
		}
		
		public void writeXml(cur newCur){
			// delete entry
			if (newCur.ratio == "-1"){
				deleteXml(newCur.name);
			}
			// update entry
			else if (convert(newCur.name,newCur.name) != -1){
				updateXml(newCur.name,newCur.ratio);
			}
			// make new entry
			else{
				XmlDocument doc = new XmlDocument();
            	doc.Load(filename);
				XmlElement subRoot = doc.CreateElement("entry");
				
				// Currency name
				XmlElement appendedElementName = doc.CreateElement("name");
				XmlText txtName = doc.CreateTextNode(newCur.name);
				appendedElementName.AppendChild(txtName);
				subRoot.AppendChild(appendedElementName);
				doc.DocumentElement.AppendChild(subRoot);
				// Currency ratio			 
				XmlElement appendedElementRatio=doc.CreateElement("ratio");
				XmlText txtRatio = doc.CreateTextNode(newCur.ratio);
				appendedElementRatio.AppendChild(txtRatio);
				subRoot.AppendChild(appendedElementRatio);
				doc.DocumentElement.AppendChild(subRoot);
	
				doc.Save(filename);
			}
		}
		public string[] getAllNames(){
			cur[] all = readXml();
			string[] names = new string[all.Length];
			int i=0;
			foreach (cur c in all){
				names[i++] = c.name;	
			}
			return names;
		}
		public cur[] readXml(){
			ArrayList items = new ArrayList();
			XmlDocument doc = new XmlDocument();
            doc.Load(filename);
            XmlElement root = doc.DocumentElement;
            XmlNodeList nodes = root.SelectNodes("entry"); 
            foreach (XmlNode node in nodes)
            {
				cur c;
				c.name = node["name"].InnerText;
				c.ratio = node["ratio"].InnerText;
				items.Add(c);
            }
			return (cur[])(items.ToArray(typeof(cur)));
		}
		
		public void deleteXml(string name){
			XmlDocument doc = new XmlDocument();
            doc.Load(filename);
            XmlElement root = doc.DocumentElement;
            XmlNodeList nodes = root.SelectNodes("entry"); 
            foreach (XmlNode node in nodes)
            {
				if (node["name"].InnerText == name){
					node.ParentNode.RemoveChild(node);
				}
            }
			doc.Save(filename);
		}
		
		public void updateXml(string name, string ratio){
			cur c;
			c.name = name;
			c.ratio = ratio;
			updateXml(c);
		}
		
		public void updateXml(cur c){
			XmlDocument doc = new XmlDocument();
            doc.Load(filename);
            XmlElement root = doc.DocumentElement;
            XmlNodeList nodes = root.SelectNodes("entry"); 
            foreach (XmlNode node in nodes)
            {
				if (node["name"].InnerText == c.name){
					node["ratio"].InnerText = c.ratio;
				}
            }
			doc.Save(filename);
		}
	}
}
